package flux;

/**
 * HttpFileTransferAction that supports downloading files from web server.
 *
 * @author arul@flux.ly
 */
public interface HttpFileTransferAction extends Action {

  /**
   * Sets the destination filename. This is the directory where the file
   * is downloaded to. For example, you could specify "downloads/flux-plugins.zip".
   *
   * @param destination Destination filename.
   */
  public void setDestination(String destination);

  /**
   * Sets the source filename. This is typically a HTTP URL such as
   * https://bitbucket.org/aruld/flux-plugins/downloads/flux-plugins-1.0.2.zip
   *
   * @param source Source filename.
   */
  public void setSource(String source);
}
