package flux;

/**
 * RabbitMQ shared by RabbitMQAction for publishing messages
 * and RabbitMQTrigger for consuming messages.
 *
 * @author arul@flux.ly
 */
public interface RabbitMQ {
  /**
   * RabbitMQ host name where the broker in running.
   *
   * @param host name of the host where broker is running.
   */
  public void setHost(String host);

  /**
   *  Set the password. Defaults to "guest".
   *
   * @param password password.
   */
  public void setPassword(String password);

  /**
   * Set the target port. Defaults to 5672.
   *
   * @param port target port.
   */
  public void setPort(int port);

  /**
   * Specify queue name if you are using a shared queue.
   *
   * @param queueName queue name.
   */
  public void setQueueName(String queueName);

  /**
   * Set the user name.
   *
   * @param username username.
   */
  public void setUsername(String username);

  /**
   * Set the virtual host.
   *
   * @param virtualHost virtual host.
   */
  public void setVirtualHost(String virtualHost);
}
