package fluximpl;

import org.apache.cxf.configuration.security.AuthorizationPolicy;
import org.apache.cxf.jaxrs.ext.RequestHandler;
import org.apache.cxf.jaxrs.model.ClassResourceInfo;
import org.apache.cxf.message.Message;

import javax.ws.rs.core.Response;

public class AuthenticationHandler implements RequestHandler {
  private String username;
  private String password;

  public AuthenticationHandler(String username, String password) {
    this.username = username;
    this.password = password;
  }

  public Response handleRequest(Message m, ClassResourceInfo resourceClass) {
    AuthorizationPolicy policy = m.get(AuthorizationPolicy.class);
    if (policy == null) {
      return Response.status(401).header("WWW-Authenticate", "Basic").build();
    }
    String username = policy.getUserName();
    String password = policy.getPassword();
    if (isAuthenticated(username, password)) {
      // let request to continue
      return null;
    } else {
      // authentication failed, request the authentication, add the realm name if needed to the value of WWW-Authenticate
      return Response.status(401).header("WWW-Authenticate", "Basic").build();
    }
  }

  private boolean isAuthenticated(String usernameInContext, String passwordInContext) {
    return usernameInContext.equals(username) && passwordInContext.equals(password);
  }
}