package fluximpl;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.util.Map;

/**
 * FlowChartListener WebService.
 *
 * @author arul@flux.ly
 */
@WebService(targetNamespace = "http://flux.ly")
@Path("/")
public interface FlowChartListener {

  @WebMethod(operationName = "expediteWithVariables")
  @POST
  @Path("expediteWithVariables")
  long expedite(@WebParam(name = "variables") @XmlJavaTypeAdapter(StringMapAdapter.class) Map<String, String> variables);

  @WebMethod(operationName = "expedite")
  @GET
  @Path("expedite")
  long expedite();

  @WebMethod(operationName = "dispose")
  @POST
  @Path("dispose")
  void dispose();

  @WebMethod(operationName = "running")
  @GET
  @Path("running")
  boolean isRunning();
}
