package fluximpl;

import java.beans.BeanDescriptor;
import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;
import java.util.Arrays;
import java.util.Vector;

/**
 * BeanInfo for the web and desktop designer.
 *
 * @author Copyright 2012 Flux Corporation. All rights reserved.
 */
public class JmsTriggerImplBeanInfo extends ActionImplBeanInfo {

  protected BeanDescriptor bd = new BeanDescriptor(JmsTriggerImpl.class);

  public JmsTriggerImplBeanInfo(final BeanDescriptor bd) {
    super();
    this.bd = bd;
  }


  public JmsTriggerImplBeanInfo() {
    super();
    this.bd.setDisplayName("JMS Trigger");
    this.bd.setShortDescription("Wait for a message to appear on a JMS server");
  }


  @Override
  public BeanDescriptor getBeanDescriptor() {
    return this.bd;
  }


  /**
   * Returns all JavaBean descriptors described by this BeanInfo.
   *
   * @return All JavaBean descriptors described by this BeanInfo.
   */
  @Override
  public PropertyDescriptor[] getPropertyDescriptors() {
    final Vector<PropertyDescriptor> descriptors =
        new Vector<PropertyDescriptor>(Arrays.asList(super.getPropertyDescriptors()));

    try {
      int order = 10;

      descriptors.add(makePropertyDescriptor("listeningQueueName", "Listening Queue Name", "fluximpl.JmsTriggerImpl", "getListeningQueueName", true, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("fetchAllMessages", "Fetch All Messages", "fluximpl.JmsTriggerImpl", "isFetchAllMessages", false, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("connectionFactory", "Connection Factory", "fluximpl.JmsTriggerImpl", "getConnectionFactory", true, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("initialContextFactory", "Initial Context Factory", "fluximpl.JmsTriggerImpl", "getInitialContextFactory", true, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("extraInitialContextProperties", "Extra Initial Context Properties", "fluximpl.JmsTriggerImpl", "getExtraInitialContextProperties", true, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("providerUrl", "Provider URL", "fluximpl.JmsTriggerImpl", "getProviderUrl", true, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("username", "Username", "fluximpl.JmsTriggerImpl", "getUsername", false, null, order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("password", "Password", "fluximpl.JmsTriggerImpl", "getPassword", false, null, order++, false, false, false, true));
      descriptors.add(makePropertyDescriptor("pollingDelay", "Polling Delay", "fluximpl.JmsTriggerImpl", "getPollingDelay", false, "fluximpl.TimeExpressionEditor", order++, false, false, false, false));
      descriptors.add(makePropertyDescriptor("messageSelector", "Message Selector", "fluximpl.JmsTriggerImpl", "getMessageSelector", false, null, order++, false, false, false, false));
    } catch (Exception e) {
      e.printStackTrace();
    }

    descriptors.addAll(Arrays.asList(super.getPropertyDescriptors()));
    return descriptors.toArray(new PropertyDescriptor[descriptors.size()]);
  } // getPropertyDescriptors()
}