package fluximpl;

import org.apache.ws.security.WSPasswordCallback;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;
import java.io.IOException;

public class ServerPasswordCallbackHandler implements CallbackHandler {
  private String username;
  private String password;

  public ServerPasswordCallbackHandler(String username, String password) {
    this.username = username;
    this.password = password;
  }

  public void handle(Callback[] callbacks) throws IOException,
    UnsupportedCallbackException {

    WSPasswordCallback pc = (WSPasswordCallback) callbacks[0];
    if (pc.getIdentifier().equals(username)) {
      // set the password on the callback. This will be compared to the
      // password which was sent from the client.
      pc.setPassword(password);
    }
  }

}