package fluximpl;

import javax.xml.bind.annotation.adapters.XmlAdapter;
import java.util.LinkedHashMap;
import java.util.Map;

public class StringMapAdapter extends XmlAdapter<StringMap, Map<String, String>> {
  public StringMap marshal(Map<String, String> v) throws Exception {
    StringMap map = new StringMap();
    for (Map.Entry<String, String> e : v.entrySet()) {
      StringMap.StringEntry iue = new StringMap.StringEntry();
      iue.setValue(e.getValue());
      iue.setKey(e.getKey());
      map.getVariables().add(iue);
    }
    return map;
  }

  public Map<String, String> unmarshal(StringMap v) throws Exception {
    Map<String, String> map = new LinkedHashMap<String, String>();
    for (StringMap.StringEntry e : v.getVariables()) {
      map.put(e.getKey(), e.getValue());
    }
    return map;
  }
}
